package cz.cvut.fel.pr1.week4;

import java.util.Scanner;

public class TimeCalculator {

    final int SECONDS_IN_MINUTE = 60;
    final int SECONDS_IN_HOUR = SECONDS_IN_MINUTE * 60;
    
    //BAD -- the method execute() is to long, should be decomposed into more
    void execute() {
        int hours1, hours2;
        int minutes1, minutes2;
        Scanner sc = new Scanner(System.in);
        
        hours1 = loadField("hours of the first time", sc);
        hours1 = validateHours(hours1);
        minutes1 = loadField("minutes of the first time", sc);
        minutes1 = validateMinutes(minutes1);
        
        hours2 = validateHours(loadField("hours of the second time", sc));
        
        //BAD -- validateMinutes would be better
        minutes2 = validateRange(loadField("minutes of the first time", sc), 60);
        
        
        int seconds1 = hours1 * SECONDS_IN_HOUR + minutes1 * SECONDS_IN_MINUTE;
        int seconds2 = hours2 * SECONDS_IN_HOUR + minutes2 * SECONDS_IN_MINUTE;
        
        if (seconds1 > seconds2) {
            error("The first time is after the second one.");
        }
        
        int secondsResult = seconds2 - seconds1;
        int hoursResult = secondsResult / SECONDS_IN_HOUR;
        int minutesResult = (secondsResult % SECONDS_IN_HOUR) / SECONDS_IN_MINUTE;

        System.out.printf("The difference is %02d:%02d\n", // <-- see how the function call spreads across two lines?
                hoursResult, minutesResult);
    }
    
    int loadField(String name, Scanner sc) {
        System.out.print("Enter "+ name +": ");
        return sc.nextInt();
    }
    
    //TODO better name of method
    int validateHours(int hours) {
        return validateRange(hours, 24);
    }
    
    //TODO better name of method
    int validateMinutes(int minutes) {
        return validateRange(minutes, 60);
    }
    
    //TODO better name of method
    int validateRange(int value, int range) {
        //System.err.println("ERROR");
        if (value > range) {
            System.err.println("ERROR");
        }
        
        return value % range;
    }
    
    void error(String errorMessage) {
        System.out.println(errorMessage);
        System.exit(0);
    }
    
    public static void main(String[] args) {
        //This is the uses the same principle as Lecture4 templete. Only instead
        //of two methods (vstup() and vystup()) only one is called
        TimeCalculator calculator = new TimeCalculator();
        calculator.execute();
    }
    
}
