package cz.cvut.fel.pr1.week8;

public class MyLinkedList {
    
    private Element first, last;
    private int size = 0;
    
    public void add(Rectangle rectangle) {
        Element element = new Element(rectangle);
        
        if (isEmpty()) {
            first = element;
            last = element;
        } else {
            last.setNext(element);
            last = element;
        }
        
        size++;
    }

    public boolean isEmpty() {
        return first == null && last == null;
    }
    
    public void removeFirst() {
        if (isEmpty()) {
            //If list is already empty, remove operation is not well defined
            throw new IllegalStateException("Cannot remove from empty list");
        }
        
        first = first.getNext(); //That's all :-)
        size--;
    }
    
    public int size() {
        if (isEmpty()) {
            return 0;
        }
        
        Element current = first;
        int size = 1;
        while (current.getNext() != null) {
            size += 1;
            current = current.getNext();
        }
        
        return size;
        
    }
    
}
