package cz.cvut.fel.pr1.week5;

import java.util.Scanner;

public class Lecture5 {

    boolean isPrimeNumber(int number) {
        if (number <= 1) {
            return false;
        } else { // QUESTION: Is else really necessary here?
            //For prime number we need to test only to sqrt of the number
            //The ceil function returns closest integer (celočíselnou) value
            //of the given number
            int bound = (int) Math.ceil(Math.sqrt(number));
            
            //Check some singularity (výjimečná situace)
            if (bound == number) {
                bound -= 1;
            }
            
            for (int i = 2; i <= bound; i++) {
                if (number % i == 0) { //i is divisor of the number
                    return false; 
                }
            }
            return true;
        }
    }
    
    void writeDivisors(int number) {
        System.out.print("Divisors of "+ number + ": ");
        for (int i = 1; i < number; i++) {
            if (number % i == 0) {
                System.out.print(i + ", ");
            }
        }
        
        //Number is divisor of itsefl
        System.out.println(number);
    }
    
    void numberSequence() {
        Scanner sc = new Scanner(System.in);
        
        System.out.println("Enter sequence");
        
        int max = Integer.MIN_VALUE,
            min = Integer.MAX_VALUE,
            sum = 0,
            divisor = 0;
        
        int inputNumber = sc.nextInt();
        
        while (inputNumber != 0) {
            max = max(max, inputNumber);
            min = min(min, inputNumber);
            sum += inputNumber;
            divisor += 1; //or divisor++; :-)
            
            //Read next number
            inputNumber = sc.nextInt();
        }
        
        if (divisor > 0) {
            printResults(max, min, sum, divisor);
        } else {
            System.out.println("No sequence was inserted");
        }
    }
    
    int max(int a, int b) { //Look at usage of ternary operator : ?
        return a < b ? b : a;
    }
    
    int min(int a, int b) { 
        /*
         * Unlike max(int, int) function we use if statement, the code is 
         * equivalent. Only one time we return max and other time we return min :-)
         */
        if (a < b) {
            return a;
        } else {
            return b;
        }
        
    }
    
    void printResults(int max, int min, int sum, int divisor) {
        double mean = (double) sum / divisor;
        
        System.out.println("Max value: "+ max);
        System.out.println("Min value: "+ min);
        System.out.println("Mean value: "+ mean);
    }
    
    public static void main(String[] args) {
        Lecture5 lecture5 = new Lecture5();
        
        System.out.println("Prime numbers:");
        for (int i = 0; i < 25; i++) {
            System.out.println(i + ": "+ lecture5.isPrimeNumber(i));
        }
        
        System.out.println("------------------");
        System.out.println("Divisors:");
        lecture5.writeDivisors(10);
        lecture5.writeDivisors(100);
        
        lecture5.numberSequence();
    }
    
    
}
