package cz.cvut.fel.pr1.week6;

public class Lecture6 {
    
    String name;
    
    public Lecture6(String name) {
        this.name = name;
    }
    
    String reverse(String input) {
        
        if (input == null) {
            return null;
        }
        
        String out = "";
        //Iterating backwards
        for (int i = input.length() - 1; i >= 0; i--) {
            out += input.charAt(i); //This is actually very unefficient
        }
        
        return out;
    }
    
    int fibIter(int n) {
        if (n == 0) {
            return 0;
        }
        
        int prev1 = 0, 
            prev2 = 1;
        
        for (int i = 3; i <= n; i++) {
            int actual = prev1 + prev2;
            prev1 = prev2;
            prev2 = actual;
        }
        
        return prev1 + prev2;
    }
    
    int factIter(int n) {
        int acc = 1;
        for (int i = 1; i <= n; i++) {
            acc *= i;
        }
        return acc;
    }
    
    public static void main(String[] args) {
        Lecture6 lecture = new Lecture6("test");
        lecture.fibIter(100);
    }
    
}
