package cz.cvut.fel.pr1.week8;

public class Element {

    private Element next;
    private Rectangle rectangle;

    public Element(Rectangle rectangle) {
        this(rectangle, null);
    }
    
    public Element(Rectangle rectangle, Element next) {
        this.next = next;
        this.rectangle = rectangle;
    }

    public Element getNext() {
        return next;
    }

    public void setNext(Element next) {
        this.next = next;
    }
    
    public Rectangle getRectangle() {
        return rectangle;
    }

}
